module Clarc
  class RepositoryBase
    class << self
      def all
        wrap(persistance_class.all)
      end

      def find id
        wrap(persistance_class.find(id))
      end

      def save model
        persisted = persistance_class.new(model.to_hash)
        result = persisted.save
        model.id = persisted.id
        result
      end

      protected

      def wrap result
        case result
        when Array, ActiveRecord::Relation
          result.map{ |p| model_class.new(p.attributes) }
        when ActiveRecord::Base
          model_class.new(result.attributes)
        else
          raise "unknown type - #{result.class}"
        end
      end

      def model_class
        "#{name.gsub('Repository', '')}".constantize
      end

      def persistance_class
        "#{name.gsub('Repository', '')}Persistance".constantize
      end
    end
  end
end
