module Clarc
  class UseCaseBase
    def initialize request
      @request = request
    end

    def perform &block
      block.call(self, response)
      @blocks[response.status].call
      response
    end

    def method_missing name, *args, &block
      return super unless block_given? && args.empty?

      @blocks ||= {}
      @blocks[name.to_sym] = block
    end

    def response
      main if @response.nil?
      @response
    end

    protected

    def respond status, result
      @response = Response.new(status, result)
    end

    def params
      @params ||= ActionController::Parameters.new(@request.params)
    end
  end
end
